您的位置:首页 > 其它

POJ3126——Prime Path

2014-09-09 15:23 267 查看
Description


The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on
their offices.

— It is a matter of security to change such things every now and then, to keep the enemy in the dark.

— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!

— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.

— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!

— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.

— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.

— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.

— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?

— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033

1733

3733

3739

3779

8779

8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033

Sample Output
6
7
0

Source

简单的BFS题,先把10000以内的素数打出来,然后就是普通的BFS做法,枚举修改每一位,反正就4位数

#include<queue>
#include<cstdio>
#include<cstring>
#include<iostream>
#include<algorithm>

using namespace std;

bool is_prime[10010];
bool vis[10010];
int num[4];

struct node
{
	int x;
	int step;
};

void get_prime()
{
	for(int i=2;i<=10000;i++)
		is_prime[i]=1;
	for(int i=2;i<=10000;i++)
	{
		if(is_prime[i])
		{
			if(10000/i < i)
				break;
			for(int j=i*i;j<=10000;j+=i)
				is_prime[j]=false;
		}
	}
}

void bfs(int s,int e)
{
	queue<node>qu;
	memset(vis,0,sizeof(vis));
	while(!qu.empty())
		qu.pop();
	node tmp1,tmp2;
	tmp1.x=s;
	tmp1.step=0;
	qu.push(tmp1);
	vis[s]=1;
	bool flag=false;
	while(!qu.empty())
	{
		tmp1=qu.front();
		if(tmp1.x==e)
		{
			printf("%d\n",tmp1.step);
			flag=true;
			break;
		}
		int y=tmp1.x;
		qu.pop();
		num[0]=y/1000;
		num[1]=y/100%10;
		num[2]=y/10%10;
		num[3]=y%10;
		for(int i=0;i<4;i++)//修改第几位 
		{
			for(int j=0;j<=9;j++)
			{
				if(j==0 && i==0)//修改最高位只能是1-9 
					continue;
				if(num[i]!=j)
				{
					int cnt=1000,newx=0;
					for(int k=0;k<4;k++)
					{
						if(k!=i)
							newx+=num[k]*cnt;
						else
							newx+=j*cnt;
						cnt/=10;
					}
//					printf("%d\n",newx);
					if(!vis[newx] && is_prime[newx])
					{
						vis[newx]=1;
						tmp2.x=newx;
						tmp2.step=tmp1.step+1;
						qu.push(tmp2);
					}
				}   
			}
		}
	}
	if(!flag)
		printf("Impossible\n");
}

int main()
{
	int t;
	scanf("%d",&t);
	get_prime();
	while(t--)
	{
		int s,e;
		scanf("%d%d",&s,&e);
		bfs(s,e);
	}
	return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: